=== debian/tests/control ===
Tests:
    01_regular-tests,
Depends: 
    babeltrace,
    bash,
    bash-completion,
    bc,
    build-essential, 
    coreutils, 
    dotnet7,
    dotnet-sdk-7.0-source-built-artifacts,
    file, 
    findutils,
    git,
    jq, 
    lldb, 
    lttng-tools, 
    npm, 
    postgresql,
    python3,
    sed, 
    strace,
    tar,
    unixodbc, 
    wget,
    zlib1g-dev,
Restrictions: 
    allow-stderr,
    needs-internet,
    needs-root,
